package com.ematou.wxbase.service.impl;

import com.ematou.wxbase.entity.EidTokenRecord;
import com.ematou.wxbase.mapper.EidTokenRecordMapper;
import com.ematou.wxbase.service.EidTokenRecordService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.UUID;

/**
 * E证通 token 实现类
 *
 * @author frankeleyn
 * @email lvjian@qhdswl.com
 * @date 2023/2/16 15:30
 */
@Service
public class EidTokenRecordServiceImpl implements EidTokenRecordService {

    private static final Logger log = LoggerFactory.getLogger(EidTokenRecordServiceImpl.class);

    @Resource
    private EidTokenRecordMapper eidTokenRecordMapper;

    @Override
    public String getEidToken(String merchSn) {

        String token = UUID.randomUUID().toString().replace("-", "");
        insertRecord(merchSn, token);

        return token;
    }

    private void insertRecord(String merchSn, String token) {
        LocalDateTime localDateTime = LocalDateTime.now();
        EidTokenRecord record = new EidTokenRecord();
        record.setToken(token);
        record.setMerchSn(merchSn);
        record.setGenerationTime(localDateTime);
        record.setExpireTime(localDateTime.plusMinutes(1));

        int insert = eidTokenRecordMapper.insert(record);
        log.debug("插入是否成功 => {}", insert);
    }


}
